# Copyright 2006  Daniel Harple

require "English"

module SVG2AAMap
  class PathData
    
    def tokenize(d)
      d.split(/[\s,]+/)
    end
    
    def parse(d)
      tokens = tokenize(d)
      parsed = []
      context = nil
      while token = tokens.shift
        case token
        when "M"
          context = "M"
        when "m"
          context = "m"
        when "L"
          context = "L"
        when "l"
          context = "l"
        when /[-+]?\d+(?:\.\d+)?(?:[eE][+-]?\d+)?/
          case context
          when "M", "L"
            parsed << Float($MATCH)
          when "m", "l"
            last = parsed[-2]
            this = Float($MATCH)
            parsed << last + this
          end
        when "z", "Z"
          context = nil
          close_path = [parsed[0], parsed[1]]
          parsed += close_path
        end
      end
      parsed
    end
    
  end
end